package nianioTest.complib.controls;

import genrap.ui.framework.CompHandle;
import nianio.complib.controls.LabelCommand;
import ocean.common.Err;
import ocean.models.SimpleModel;

public class Label {
	private final SimpleModel text;
	private final CompHandle label;

	private Label(String text) {
		this.text = new SimpleModel(text);
		this.label = genrap.ui.compLib.j2se.comps.Label.create(this.text.getModel());
	}

	public static Label create(String text) {
		return new Label(text);
	}

	public void post(LabelCommand cmd) {
		if (cmd.isSetText()) {
			String newText = cmd.asSetText();
			if (!newText.equals(text.get()))
				text.set(newText);
		} else
			throw Err.errM(cmd);
	}

	public CompHandle getHandle() {
		return label;
	}
}
