package nianioTest.complib.repository;

import genrap.ui.framework.CompHandle;

import java.util.HashMap;
import java.util.Map;

import nianio.complib.controls.ControlIdEvent;
import nianio.complib.controls.TextBoxEvent;
import nianio.complib.controls.TextBoxState;
import nianio.ids.TextBoxId;
import nianioTest.complib.controls.TextBox;

public class TextBoxRepository {
	private final CompsMap compsMap = new CompsMap();
	private final ControlIdEvent.MMIntf deliverer;

	public TextBoxRepository(ControlIdEvent.MMIntf deliverer) {
		this.deliverer = deliverer;
	}

	private static class CompsMap {
		private Map compsMap;

		public CompsMap() {
			this.compsMap = new HashMap();
		}

		public void put(TextBoxId id, TextBox comp) {
			this.compsMap.put(id, comp);
		}

		public TextBox get(TextBoxId id) {
			return (TextBox) this.compsMap.get(id);
		}
	}

	private class MyDeliverer implements TextBoxEvent.MM {
		final private TextBoxId id;

		public MyDeliverer(TextBoxId id) {
			this.id = id;
		}

		public void invoke(TextBoxEvent cmd) {
			deliverer.textBoxEvent(id, cmd);
		}
	}

	public CompHandle addTextBox(TextBoxState state) {
		TextBoxId id = state.getId();
		TextBox textBox = TextBox.create(state.getText(), state.getRows(),
				state.getCols(), state.getPassword(),
				state.getPreserveSelection(), new MyDeliverer(id));
		compsMap.put(id, textBox);
		return textBox.getHandle();
	}

	public TextBox get(TextBoxId id) {
		return compsMap.get(id);
	}

}
