package nianioTest.complib.windows;

import genrap.ui.framework.ParentComp;

import java.awt.Component;

import javax.swing.JOptionPane;

import nianio.complib.messagedialog.MessageDialogEvent;
import nianio.complib.messagedialog.MessageDialogIdParams;
import nianio.complib.messagedialog.MessageDialogKind;
import ocean.common.Err;

public class MessageDialog {
	public static void show(MessageDialogIdParams params, ParentComp parent,
			MessageDialogEvent.MMIntf invoker) {
		String message = params.getParams().getMessage();
		MessageDialogKind kind = params.getParams().getDialogKind();
		if (kind.isInfo()) {
			JOptionPane.showMessageDialog(tryGetNativeComp(parent), message,
					"Information", JOptionPane.INFORMATION_MESSAGE);
		} else if (kind.isWarning()) {
			JOptionPane.showMessageDialog(tryGetNativeComp(parent), message,
					"Warning", JOptionPane.WARNING_MESSAGE);
		} else if (kind.isError()) {
			JOptionPane.showMessageDialog(tryGetNativeComp(parent), message,
					"Error", JOptionPane.ERROR_MESSAGE);
		} else
			throw Err.errM(kind);
		invoker.closed(params.getId());
	}

	private static Component tryGetNativeComp(ParentComp parent) {
		if (parent.isDialog())
			return parent.asDialog();
		else if (parent.isFrame())
			return parent.asFrame();
		else
			return null;
	}
}
