package nianioTest.nianio.impl;

import nianio.AppCommand;
import nianio.AppLogicCmd;
import nianio.AppLogicExtCmd;
import nianio.AppLogicExtCmds;
import nianio.AppState;
import nianio.ExternalCommand;
import nianio.AppLogicExtCmd.MMIntf;
import nianio.ExternalCommand.MM;
import nianioTest.nianio.cmdsfact.AppLogicCmdFact;
import nianioTest.nianio.cmdsfact.ExternalCommandFact;
import nianioTest.nianio.helper.MessageHelper;
import nianioTest.nianio.types.AppLogicExtCmdAcc;
import nianioTest.nianio.types.AppLogicNianio;
import nianioTest.nianio.types.AppNianioIntf;

public class AppNianioImpl implements AppNianioIntf {

	public AppState invoke(AppState state, AppCommand cmd,
			ExternalCommand.MM deliverer) {
		AppLogicCmd lCmd = AppLogicCmdFact.tryCreate(cmd);
		if (lCmd == null)
			return state;
		AppLogicExtCmdAcc acc = new AppLogicExtCmdAcc();
		AppState newState = AppLogicNianio.create(new AppLogicCommandInvoker()).invoke(
				state, lCmd, acc.getMMIntf());
		updateUI(state, newState, acc.getMMIntf());
		sendExternal(acc.getResult(), deliverer);
		return newState;
	}

	private void updateUI(AppState state, AppState newState, MMIntf intf) {
		if (!state.getOutputKind().eq(newState.getOutputKind()))
			intf.setOutput(newState.getOutputKind());
		if (!state.getStatus().eq(newState.getStatus()))
			intf.setStatus(MessageHelper.getStatusString(newState.getStatus()));
	}

	private void sendExternal(AppLogicExtCmds result, MM deliverer) {
		for(int i = 0; i < result.size(); i++){
			AppLogicExtCmd cmd = result.get(i);
			deliverer.invoke(ExternalCommandFact.create(cmd));
		}
	}
}