package nianioTest.nianio.types;

import ocean.common.Err;
import nianio.SelectFileCmd;
import nianio.SelectFileState;
import nianio.SelectFileExtCmd.MMIntf;

public class SelectFileNianio {
	public static SelectFileNianioIntf create(
			final SelectFileCmdInvokerIntf invoker) {
		return new SelectFileNianioIntf() {

			public SelectFileState invoke(SelectFileState state,
					SelectFileCmd cmd, MMIntf deliverer) {
				if (cmd.isSetFileName()) {
					return invoker.setFileName(state, cmd.asSetFileName(),
							deliverer);
				} else if (cmd.isSelectFromFileChooser()) {
					return invoker.selectFromFileChooser(state, deliverer);
				} else if (cmd.isFileSelected()) {
					return invoker.fileSelected(state, cmd.asFileSelected(),
							deliverer);
				} else
					throw Err.errM(cmd);
			}
		};
	}
}
