package nianio;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import nianio.genrap.OutputKind;


/** 
 * <pre>Autogenerated class MainFrame = {
 *		  reportFileName  : String
 *		  xmlFileName  : String
 *		  xsdFileName  : String
 *		  outputFileName  : String
 *		  outputKind  : OutputKind
 *		  status  : String
 * }</pre>
 */ 

public class MainFrame implements ImmObject {
	private static final int TYPE_HASH = 1729789716;
	private int hash = 0;

	final private String reportFileName;
	final private String xmlFileName;
	final private String xsdFileName;
	final private String outputFileName;
	final private OutputKind outputKind;
	final private String status;
			
	private MainFrame(
		 String reportFileName
		, String xmlFileName
		, String xsdFileName
		, String outputFileName
		, OutputKind outputKind
		, String status
	) {
		this.reportFileName = reportFileName;
		this.xmlFileName = xmlFileName;
		this.xsdFileName = xsdFileName;
		this.outputFileName = outputFileName;
		this.outputKind = outputKind;
		this.status = status;
	}
	

	/** Creates a struct record with given values
	 * @param reportFileName != null (mandatory)
	 * @param xmlFileName != null (mandatory)
	 * @param xsdFileName != null (mandatory)
	 * @param outputFileName != null (mandatory)
	 * @param outputKind != null (mandatory)
	 * @param status != null (mandatory)
	 */
	public static MainFrame create(
		 String reportFileName
		, String xmlFileName
		, String xsdFileName
		, String outputFileName
		, OutputKind outputKind
		, String status
	) {
		SchemaException.ensure(reportFileName != null);
		SchemaException.ensure(xmlFileName != null);
		SchemaException.ensure(xsdFileName != null);
		SchemaException.ensure(outputFileName != null);
		SchemaException.ensure(outputKind != null);
		SchemaException.ensure(status != null);

		return new MainFrame(
			 reportFileName
			, xmlFileName
			, xsdFileName
			, outputFileName
			, outputKind
			, status
		);		
	}


	/* getters */
	
	/** field reportFileName, should never return null */
	public String getReportFileName() {
		return this.reportFileName;
	}
	/** field xmlFileName, should never return null */
	public String getXmlFileName() {
		return this.xmlFileName;
	}
	/** field xsdFileName, should never return null */
	public String getXsdFileName() {
		return this.xsdFileName;
	}
	/** field outputFileName, should never return null */
	public String getOutputFileName() {
		return this.outputFileName;
	}
	/** field outputKind, should never return null */
	public OutputKind getOutputKind() {
		return this.outputKind;
	}
	/** field status, should never return null */
	public String getStatus() {
		return this.status;
	}

	/* setters */
	
	/** create struct with field reportFileName modified, 
	 * (exception when arg==null) */
	public MainFrame setReportFileName(String reportFileName) {	 
		SchemaException.ensure(reportFileName != null);
		return new MainFrame(
			  reportFileName 		
			, this.xmlFileName 		
			, this.xsdFileName 		
			, this.outputFileName 		
			, this.outputKind 		
			, this.status 		
		);		
	}
	/** create struct with field xmlFileName modified, 
	 * (exception when arg==null) */
	public MainFrame setXmlFileName(String xmlFileName) {	 
		SchemaException.ensure(xmlFileName != null);
		return new MainFrame(
			  this.reportFileName 		
			, xmlFileName 		
			, this.xsdFileName 		
			, this.outputFileName 		
			, this.outputKind 		
			, this.status 		
		);		
	}
	/** create struct with field xsdFileName modified, 
	 * (exception when arg==null) */
	public MainFrame setXsdFileName(String xsdFileName) {	 
		SchemaException.ensure(xsdFileName != null);
		return new MainFrame(
			  this.reportFileName 		
			, this.xmlFileName 		
			, xsdFileName 		
			, this.outputFileName 		
			, this.outputKind 		
			, this.status 		
		);		
	}
	/** create struct with field outputFileName modified, 
	 * (exception when arg==null) */
	public MainFrame setOutputFileName(String outputFileName) {	 
		SchemaException.ensure(outputFileName != null);
		return new MainFrame(
			  this.reportFileName 		
			, this.xmlFileName 		
			, this.xsdFileName 		
			, outputFileName 		
			, this.outputKind 		
			, this.status 		
		);		
	}
	/** create struct with field outputKind modified, 
	 * (exception when arg==null) */
	public MainFrame setOutputKind(OutputKind outputKind) {	 
		SchemaException.ensure(outputKind != null);
		return new MainFrame(
			  this.reportFileName 		
			, this.xmlFileName 		
			, this.xsdFileName 		
			, this.outputFileName 		
			, outputKind 		
			, this.status 		
		);		
	}
	/** create struct with field status modified, 
	 * (exception when arg==null) */
	public MainFrame setStatus(String status) {	 
		SchemaException.ensure(status != null);
		return new MainFrame(
			  this.reportFileName 		
			, this.xmlFileName 		
			, this.xsdFileName 		
			, this.outputFileName 		
			, this.outputKind 		
			, status 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof MainFrame) 
			&& this.eq((MainFrame)obj);
	}
	
	public boolean eq(MainFrame obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqReportFileName(this, obj)
			&& eqXmlFileName(this, obj)
			&& eqXsdFileName(this, obj)
			&& eqOutputFileName(this, obj)
			&& eqOutputKind(this, obj)
			&& eqStatus(this, obj)
			;
	}

	private static boolean eqReportFileName(MainFrame o1, MainFrame o2) {
		String f1 = o1.getReportFileName();
		String f2 = o2.getReportFileName();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	private static boolean eqXmlFileName(MainFrame o1, MainFrame o2) {
		String f1 = o1.getXmlFileName();
		String f2 = o2.getXmlFileName();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	private static boolean eqXsdFileName(MainFrame o1, MainFrame o2) {
		String f1 = o1.getXsdFileName();
		String f2 = o2.getXsdFileName();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	private static boolean eqOutputFileName(MainFrame o1, MainFrame o2) {
		String f1 = o1.getOutputFileName();
		String f2 = o2.getOutputFileName();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	private static boolean eqOutputKind(MainFrame o1, MainFrame o2) {
		OutputKind f1 = o1.getOutputKind();
		OutputKind f2 = o2.getOutputKind();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqStatus(MainFrame o1, MainFrame o2) {
		String f1 = o1.getStatus();
		String f2 = o2.getStatus();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("reportFileName" + "=");
		out.append(getReportFileName());
		out.append(", ");
		out.append("xmlFileName" + "=");
		out.append(getXmlFileName());
		out.append(", ");
		out.append("xsdFileName" + "=");
		out.append(getXsdFileName());
		out.append(", ");
		out.append("outputFileName" + "=");
		out.append(getOutputFileName());
		out.append(", ");
		out.append("outputKind" + "=");
		out.append(getOutputKind());
		out.append(", ");
		out.append("status" + "=");
		out.append(getStatus());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.reportFileName.hashCode() + 119932107;
			h ^= this.xmlFileName.hashCode() + 357760014;
			h ^= this.xsdFileName.hashCode() + 753412800;
			h ^= this.outputFileName.hashCode() + -633033832;
			h ^= this.outputKind.hashCode() + 926384517;
			h ^= this.status.hashCode() + 2078021954;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}