package nianio;

import nianio.complib.filechooser.FileChooserParams;
import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * <pre>Autogenerated class SelectFileExtCmd = variant {
 *	    openFileChooser of FileChooserParams  
 *	 |  setFileName of String  
 * }</pre>
 */ 
public class SelectFileExtCmd implements ImmObject {
	private static final int TYPE_HASH = 888954417;
	private int hash = 0;

	private final int variant;
	private final Object value;  


	private SelectFileExtCmd(int variant, Object value) {
		SchemaException.ensure(value != null);
		this.variant = variant;
		this.value = value;
	}


	public static SelectFileExtCmd createOpenFileChooser(FileChooserParams value) {
		return new SelectFileExtCmd(0, value);
	}

	public static SelectFileExtCmd createSetFileName(String value) {
		return new SelectFileExtCmd(1, value);
	}



	/** @return true, when this is openFileChooser */
	public boolean isOpenFileChooser() {
		return variant == 0;
	}

	/** @return variant value, when this is openFileChooser; throws Exception otherwise */
	public FileChooserParams asOpenFileChooser() {
		SchemaException.ensure(isOpenFileChooser());
		return (FileChooserParams)value;
	}

	/** @return true, when this is setFileName */
	public boolean isSetFileName() {
		return variant == 1;
	}

	/** @return variant value, when this is setFileName; throws Exception otherwise */
	public String asSetFileName() {
		SchemaException.ensure(isSetFileName());
		return ((String)value);
	}



	/** The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isOpenFileChooser()) {
			;
		} else if (isSetFileName()) {
			;
		} else 		
			throw Err.errM(this);
	}

	/** The only purpose of this method is to inline its content - 
	 * match pattern with value unpacking. 
	 */ 
	public void matchUnpack() {
		if (isOpenFileChooser()) {
			asOpenFileChooser();
		} else if (isSetFileName()) {
			asSetFileName();
		} else 		
			throw Err.errM(this);
	}	

	public String toString() {
		if (isOpenFileChooser())
			return "openFileChooser" + "(" + asOpenFileChooser() + ")";
		if (isSetFileName())
			return "setFileName" + "(" + asSetFileName() + ")";
		throw SchemaException.err();
	}
	
	public boolean eq(SelectFileExtCmd obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return variant == obj.variant 
			&& (value == null ? (obj.value == null) 
			: (obj.value != null && value.equals(obj.value)));
	}

	public boolean equals(Object obj) {
		return (obj instanceof SelectFileExtCmd) 
			&& this.eq((SelectFileExtCmd)obj);
	}

	public int hashCode(){
		if (hash == 0) {
			int h = variant*(variant - 79) + 1601;
			if (value != null)
				h ^= value.hashCode();
			else
				h ^= TYPE_HASH;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
	

	// --------------- Model Manipulator Infrastructure ----------------- //

	/**
	 *  Autogenerated Model Manipulator for SelectFileExtCmd
	 */
	public static interface MM {
		public void invoke(SelectFileExtCmd cmd);
	}
	/**
	 *  Autogenerated Model Manipulator Interface for SelectFileExtCmd
	 */
	public static interface MMIntf {
		public void openFileChooser(FileChooserParams value);
		public void setFileName(String value);
 	}
	/**
	 *  Autogenerated Model Manipulator Converter for SelectFileExtCmd
	 */
	public static class MMConv {
		public static MMIntf asIntf(MM mm) {
			return new MyMMIntf(mm);
		}
	
		public static MM asSimple(MMIntf mm) {
			return new MyMM(mm);
		}
	
		private static class MyMM implements MM {
	
			private final MMIntf mm;
	
			public MyMM(MMIntf mm) {
				this.mm = mm;
			}
	
			public void invoke(SelectFileExtCmd cmd) {
				 if (cmd.isOpenFileChooser()) {
					mm.openFileChooser(cmd.asOpenFileChooser());
				} else if (cmd.isSetFileName()) {
					mm.setFileName(cmd.asSetFileName());
				 } else
					throw ocean.common.Err.err();				
			}
		}

		private static class MyMMIntf implements MMIntf {
			private final MM mm;
	
			public MyMMIntf(MM mm) {
				this.mm = mm;
			}
		
			public void openFileChooser(FileChooserParams value) {
				mm.invoke(SelectFileExtCmd.createOpenFileChooser(value));
			}
		
			public void setFileName(String value) {
				mm.invoke(SelectFileExtCmd.createSetFileName(value));
			}
		
		}
	}
}