package nianio;

import nianio.complib.filechooser.FileChooserParams;
import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;


/** 
 * <pre>Autogenerated class SelectFileState = {
 *		  fileName  : String
 *		? fileChooserState  : FileChooserParams
 * }</pre>
 */ 

public class SelectFileState implements ImmObject {
	private static final int TYPE_HASH = 1426942649;
	private int hash = 0;

	final private String fileName;
	final private FileChooserParams fileChooserState;
			
	private SelectFileState(
		 String fileName
		, FileChooserParams fileChooserState
	) {
		this.fileName = fileName;
		this.fileChooserState = fileChooserState;
	}
	

	/** Creates a struct record with given values
	 * @param fileName != null (mandatory)
	 * @param fileChooserStateOrNull may be null (optional)
	 */
	public static SelectFileState create(
		 String fileName
		, FileChooserParams fileChooserStateOrNull
	) {
		SchemaException.ensure(fileName != null);

		return new SelectFileState(
			 fileName
			, fileChooserStateOrNull
		);		
	}


	/* getters */
	
	/** field fileName, should never return null */
	public String getFileName() {
		return this.fileName;
	}
	/** field fileChooserState, may return null */
	public FileChooserParams tryGetFileChooserState() {
		return this.fileChooserState;
	}

	/* setters */
	
	/** create struct with field fileName modified, 
	 * (exception when arg==null) */
	public SelectFileState setFileName(String fileName) {	 
		SchemaException.ensure(fileName != null);
		return new SelectFileState(
			  fileName 		
			, this.fileChooserState 		
		);		
	}
	/** create struct with field fileChooserState modified
	 * (or removed, when arg==null) */
	public SelectFileState setFileChooserState(FileChooserParams fileChooserStateOrNull) {	 
		return new SelectFileState(
			  this.fileName 		
			, fileChooserStateOrNull 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof SelectFileState) 
			&& this.eq((SelectFileState)obj);
	}
	
	public boolean eq(SelectFileState obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqFileName(this, obj)
			&& eqFileChooserState(this, obj)
			;
	}

	private static boolean eqFileName(SelectFileState o1, SelectFileState o2) {
		String f1 = o1.getFileName();
		String f2 = o2.getFileName();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	private static boolean eqFileChooserState(SelectFileState o1, SelectFileState o2) {
		FileChooserParams f1 = o1.tryGetFileChooserState();
		FileChooserParams f2 = o2.tryGetFileChooserState();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("fileName" + "=");
		out.append(getFileName());
		out.append(", ");
		out.append("fileChooserState" + "=");
		out.append(tryGetFileChooserState());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.fileName.hashCode() + 2059860855;
			h ^= this.fileChooserState == null ? 446064898 : this.fileChooserState.hashCode() + 446064898;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}