package nianio.complib;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import schema.runtime.internal.datatypes.ObjectArray;


/** 
 * <pre>array of CompState
 * Autogenerated class Comps
 * </pre>
 */ 
public class Comps implements ImmObject {
	public static final Comps EMPTY = new Comps();

	private final ObjectArray arr;
	
	private Comps(ObjectArray arr) {
		this.arr = arr;
	}
	
	public Comps() {
		this(ObjectArray.ZERO);
	}
	
	public boolean eq(Comps obj) {
		return arr.equals(obj.arr);
	}

	public boolean equals(Object obj) {
		return (obj instanceof Comps) 
				&& eq((Comps)obj);
	}
	
	public int size() {
		return arr.size();
	}

	public Comps add(CompState elem) {
		SchemaException.ensure(elem != null);
		return new Comps(arr.add(elem));
	}

	public Comps put(int i, CompState elem) {
		SchemaException.ensure(elem != null);
		return new Comps(arr.put(i, elem));
	}

	public Comps insert(int pos, CompState elem) {
		SchemaException.ensure(elem != null);
		return new Comps(arr.insert(pos, elem));
	}

	public Comps remove(int index) {
		return new Comps(arr.remove(index));
	}

	public Comps move(int oldpos, int newpos) {
		return new Comps(arr.move(oldpos, newpos));
	}

	public Comps concat(Comps obj) {
		Comps res = this;
		for(int i = 0; i < obj.size(); ++i)
			res = res.add(obj.get(i));
		return res;
	}

	public CompState get(int ix) {
		CompState elem = (CompState) (arr.get(ix));
		return elem;
	}
	
	public int find(CompState elem) {
		return arr.find(elem);
	}
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("[");
		for (int i = 0; i < size(); i++) {
			sb.append(get(i));
			if (i < size()-1)
				sb.append(", ");
		}
		sb.append("]");
		return sb.toString();
	}

	public int hashCode(){
		return arr.hashCode();
	}

 
}
