package nianio.complib;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * Autogenerated class CreatedDialogCommand =
 * variant (enumeration) {
 *	    close 
 *	 |  show 
 * }
 */ 
public class CreatedDialogCommand implements ImmObject {
	private static final int TYPE_HASH = -454830341;


	private static final CreatedDialogCommand CONST_CLOSE = new CreatedDialogCommand(0);
	private static final CreatedDialogCommand CONST_SHOW = new CreatedDialogCommand(1);

	private final int variant;

	private CreatedDialogCommand(int variant) {
		this.variant = variant;
	}


	public static CreatedDialogCommand createClose() {
		return CONST_CLOSE;
	}
	
	public static CreatedDialogCommand createShow() {
		return CONST_SHOW;
	}
	

	/* The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isClose()) {
			;
		} else if (isShow()) {
			;
		} else 		
			throw Err.errM(this);
	}


	/** @return true, when this is close */
	public boolean isClose() {
		return variant == 0;
	}

	/** @return true, when this is show */
	public boolean isShow() {
		return variant == 1;
	}




	public String toString() {
		if (isClose())
			return "close";
		if (isShow())
			return "show";
		throw SchemaException.err();
	}
	
	public boolean eq(CreatedDialogCommand obj) {
		if (obj == null)
			return false;
		return variant == obj.variant;
	}
	
	public boolean equals(Object obj) {
		return (obj instanceof CreatedDialogCommand) 
			&& this.eq((CreatedDialogCommand)obj);
	}

	public int hashCode(){
		return (variant*(variant-79) + 1601) ^ TYPE_HASH;
	}

 
		
}