package nianio.complib;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * Autogenerated class FrameEvent =
 * variant (enumeration) {
 *	    closRequest 
 * }
 */ 
public class FrameEvent implements ImmObject {
	private static final int TYPE_HASH = 1698992461;


	private static final FrameEvent CONST_CLOSREQUEST = new FrameEvent(0);

	private final int variant;

	private FrameEvent(int variant) {
		this.variant = variant;
	}


	public static FrameEvent createClosRequest() {
		return CONST_CLOSREQUEST;
	}
	

	/* The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isClosRequest()) {
			;
		} else 		
			throw Err.errM(this);
	}


	/** @return true, when this is closRequest */
	public boolean isClosRequest() {
		return variant == 0;
	}




	public String toString() {
		if (isClosRequest())
			return "closRequest";
		throw SchemaException.err();
	}
	
	public boolean eq(FrameEvent obj) {
		if (obj == null)
			return false;
		return variant == obj.variant;
	}
	
	public boolean equals(Object obj) {
		return (obj instanceof FrameEvent) 
			&& this.eq((FrameEvent)obj);
	}

	public int hashCode(){
		return (variant*(variant-79) + 1601) ^ TYPE_HASH;
	}

 
		

	// --------------- Model Manipulator Infrastructure ----------------- //

	/**
	 *  Autogenerated Model Manipulator for FrameEvent
	 */
	public static interface MM {
		public void invoke(FrameEvent cmd);
	}
	/**
	 *  Autogenerated Model Manipulator Interface for FrameEvent
	 */
	public static interface MMIntf {
		public void closRequest();
 	}
	/**
	 *  Autogenerated Model Manipulator Converter for FrameEvent
	 */
	public static class MMConv {
		public static MMIntf asIntf(MM mm) {
			return new MyMMIntf(mm);
		}
	
		public static MM asSimple(MMIntf mm) {
			return new MyMM(mm);
		}
	
		private static class MyMM implements MM {
	
			private final MMIntf mm;
	
			public MyMM(MMIntf mm) {
				this.mm = mm;
			}
	
			public void invoke(FrameEvent cmd) {
				 if (cmd.isClosRequest()) {
					mm.closRequest();
				 } else
					throw ocean.common.Err.err();				
			}
		}

		private static class MyMMIntf implements MMIntf {
			private final MM mm;
	
			public MyMMIntf(MM mm) {
				this.mm = mm;
			}
		
			public void closRequest() {
				mm.invoke(FrameEvent.createClosRequest());
			}
		
		}
	}
}