package nianio.complib;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import nianio.ids.FrameId;


/** 
 * <pre>Autogenerated class FrameIdEvent = {
 *		  id  : FrameId
 *		  event  : FrameEvent
 * }</pre>
 */ 

public class FrameIdEvent implements ImmObject {
	private static final int TYPE_HASH = -645419982;
	private int hash = 0;

	final private FrameId id;
	final private FrameEvent event;
			
	private FrameIdEvent(
		 FrameId id
		, FrameEvent event
	) {
		this.id = id;
		this.event = event;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param event != null (mandatory)
	 */
	public static FrameIdEvent create(
		 FrameId id
		, FrameEvent event
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(event != null);

		return new FrameIdEvent(
			 id
			, event
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public FrameId getId() {
		return this.id;
	}
	/** field event, should never return null */
	public FrameEvent getEvent() {
		return this.event;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public FrameIdEvent setId(FrameId id) {	 
		SchemaException.ensure(id != null);
		return new FrameIdEvent(
			  id 		
			, this.event 		
		);		
	}
	/** create struct with field event modified, 
	 * (exception when arg==null) */
	public FrameIdEvent setEvent(FrameEvent event) {	 
		SchemaException.ensure(event != null);
		return new FrameIdEvent(
			  this.id 		
			, event 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof FrameIdEvent) 
			&& this.eq((FrameIdEvent)obj);
	}
	
	public boolean eq(FrameIdEvent obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqEvent(this, obj)
			;
	}

	private static boolean eqId(FrameIdEvent o1, FrameIdEvent o2) {
		FrameId f1 = o1.getId();
		FrameId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqEvent(FrameIdEvent o1, FrameIdEvent o2) {
		FrameEvent f1 = o1.getEvent();
		FrameEvent f2 = o2.getEvent();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("event" + "=");
		out.append(getEvent());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= this.event.hashCode() + -1608401078;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}