package nianio.complib;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * <pre>Autogenerated class Layout = variant {
 *	    uniLayout of UniLayoutParams  
 * }</pre>
 */ 
public class Layout implements ImmObject {
	private static final int TYPE_HASH = -2025855158;
	private int hash = 0;

	private final int variant;
	private final Object value;  


	private Layout(int variant, Object value) {
		SchemaException.ensure(value != null);
		this.variant = variant;
		this.value = value;
	}


	public static Layout createUniLayout(UniLayoutParams value) {
		return new Layout(0, value);
	}


	public static Layout mkUniLayout(
			int cols
			, int rows
			, int hGap
			, int vGap
	) {
		return createUniLayout( UniLayoutParams.create(
							cols
							, rows
							, hGap
							, vGap
							 ));
	}
	

	/** @return true, when this is uniLayout */
	public boolean isUniLayout() {
		return variant == 0;
	}

	/** @return variant value, when this is uniLayout; throws Exception otherwise */
	public UniLayoutParams asUniLayout() {
		SchemaException.ensure(isUniLayout());
		return (UniLayoutParams)value;
	}



	/** The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isUniLayout()) {
			;
		} else 		
			throw Err.errM(this);
	}

	/** The only purpose of this method is to inline its content - 
	 * match pattern with value unpacking. 
	 */ 
	public void matchUnpack() {
		if (isUniLayout()) {
			asUniLayout();
		} else 		
			throw Err.errM(this);
	}	

	public String toString() {
		if (isUniLayout())
			return "uniLayout" + "(" + asUniLayout() + ")";
		throw SchemaException.err();
	}
	
	public boolean eq(Layout obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return variant == obj.variant 
			&& (value == null ? (obj.value == null) 
			: (obj.value != null && value.equals(obj.value)));
	}

	public boolean equals(Object obj) {
		return (obj instanceof Layout) 
			&& this.eq((Layout)obj);
	}

	public int hashCode(){
		if (hash == 0) {
			int h = variant*(variant - 79) + 1601;
			if (value != null)
				h ^= value.hashCode();
			else
				h ^= TYPE_HASH;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
	
}