package nianio.complib.controls;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * Autogenerated class RadioButtonEvent =
 * variant (enumeration) {
 *	    selected 
 * }
 */ 
public class RadioButtonEvent implements ImmObject {
	private static final int TYPE_HASH = -1436473427;


	private static final RadioButtonEvent CONST_SELECTED = new RadioButtonEvent(0);

	private final int variant;

	private RadioButtonEvent(int variant) {
		this.variant = variant;
	}


	public static RadioButtonEvent createSelected() {
		return CONST_SELECTED;
	}
	

	/* The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isSelected()) {
			;
		} else 		
			throw Err.errM(this);
	}


	/** @return true, when this is selected */
	public boolean isSelected() {
		return variant == 0;
	}




	public String toString() {
		if (isSelected())
			return "selected";
		throw SchemaException.err();
	}
	
	public boolean eq(RadioButtonEvent obj) {
		if (obj == null)
			return false;
		return variant == obj.variant;
	}
	
	public boolean equals(Object obj) {
		return (obj instanceof RadioButtonEvent) 
			&& this.eq((RadioButtonEvent)obj);
	}

	public int hashCode(){
		return (variant*(variant-79) + 1601) ^ TYPE_HASH;
	}

 
		

	// --------------- Model Manipulator Infrastructure ----------------- //

	/**
	 *  Autogenerated Model Manipulator for RadioButtonEvent
	 */
	public static interface MM {
		public void invoke(RadioButtonEvent cmd);
	}
	/**
	 *  Autogenerated Model Manipulator Interface for RadioButtonEvent
	 */
	public static interface MMIntf {
		public void selected();
 	}
	/**
	 *  Autogenerated Model Manipulator Converter for RadioButtonEvent
	 */
	public static class MMConv {
		public static MMIntf asIntf(MM mm) {
			return new MyMMIntf(mm);
		}
	
		public static MM asSimple(MMIntf mm) {
			return new MyMM(mm);
		}
	
		private static class MyMM implements MM {
	
			private final MMIntf mm;
	
			public MyMM(MMIntf mm) {
				this.mm = mm;
			}
	
			public void invoke(RadioButtonEvent cmd) {
				 if (cmd.isSelected()) {
					mm.selected();
				 } else
					throw ocean.common.Err.err();				
			}
		}

		private static class MyMMIntf implements MMIntf {
			private final MM mm;
	
			public MyMMIntf(MM mm) {
				this.mm = mm;
			}
		
			public void selected() {
				mm.invoke(RadioButtonEvent.createSelected());
			}
		
		}
	}
}