package nianio.complib.controls;

import schema.runtime.datatypes.ImmObject;
import nianio.ids.RadioButtonId;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * <pre>Autogenerated class RadioButtonGroupCommand = variant {
 *	    select of RadioButtonId  
 * }</pre>
 */ 
public class RadioButtonGroupCommand implements ImmObject {
	private static final int TYPE_HASH = -395836583;
	private int hash = 0;

	private final int variant;
	private final Object value;  


	private RadioButtonGroupCommand(int variant, Object value) {
		SchemaException.ensure(value != null);
		this.variant = variant;
		this.value = value;
	}


	public static RadioButtonGroupCommand createSelect(RadioButtonId value) {
		return new RadioButtonGroupCommand(0, value);
	}



	/** @return true, when this is select */
	public boolean isSelect() {
		return variant == 0;
	}

	/** @return variant value, when this is select; throws Exception otherwise */
	public RadioButtonId asSelect() {
		SchemaException.ensure(isSelect());
		return (RadioButtonId)value;
	}



	/** The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isSelect()) {
			;
		} else 		
			throw Err.errM(this);
	}

	/** The only purpose of this method is to inline its content - 
	 * match pattern with value unpacking. 
	 */ 
	public void matchUnpack() {
		if (isSelect()) {
			asSelect();
		} else 		
			throw Err.errM(this);
	}	

	public String toString() {
		if (isSelect())
			return "select" + "(" + asSelect() + ")";
		throw SchemaException.err();
	}
	
	public boolean eq(RadioButtonGroupCommand obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return variant == obj.variant 
			&& (value == null ? (obj.value == null) 
			: (obj.value != null && value.equals(obj.value)));
	}

	public boolean equals(Object obj) {
		return (obj instanceof RadioButtonGroupCommand) 
			&& this.eq((RadioButtonGroupCommand)obj);
	}

	public int hashCode(){
		if (hash == 0) {
			int h = variant*(variant - 79) + 1601;
			if (value != null)
				h ^= value.hashCode();
			else
				h ^= TYPE_HASH;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
	

	// --------------- Model Manipulator Infrastructure ----------------- //

	/**
	 *  Autogenerated Model Manipulator for RadioButtonGroupCommand
	 */
	public static interface MM {
		public void invoke(RadioButtonGroupCommand cmd);
	}
	/**
	 *  Autogenerated Model Manipulator Interface for RadioButtonGroupCommand
	 */
	public static interface MMIntf {
		public void select(RadioButtonId value);
 	}
	/**
	 *  Autogenerated Model Manipulator Converter for RadioButtonGroupCommand
	 */
	public static class MMConv {
		public static MMIntf asIntf(MM mm) {
			return new MyMMIntf(mm);
		}
	
		public static MM asSimple(MMIntf mm) {
			return new MyMM(mm);
		}
	
		private static class MyMM implements MM {
	
			private final MMIntf mm;
	
			public MyMM(MMIntf mm) {
				this.mm = mm;
			}
	
			public void invoke(RadioButtonGroupCommand cmd) {
				 if (cmd.isSelect()) {
					mm.select(cmd.asSelect());
				 } else
					throw ocean.common.Err.err();				
			}
		}

		private static class MyMMIntf implements MMIntf {
			private final MM mm;
	
			public MyMMIntf(MM mm) {
				this.mm = mm;
			}
		
			public void select(RadioButtonId value) {
				mm.invoke(RadioButtonGroupCommand.createSelect(value));
			}
		
		}
	}
}