package nianio.complib.controls;

import schema.runtime.datatypes.ImmObject;
import nianio.ids.RadioButtonGroupId;
import schema.runtime.err.SchemaException;


/** 
 * <pre>Autogenerated class RadioButtonGroupIdEvent = {
 *		  id  : RadioButtonGroupId
 *		  cmd  : RadioButtonGroupEvent
 * }</pre>
 */ 

public class RadioButtonGroupIdEvent implements ImmObject {
	private static final int TYPE_HASH = 282628685;
	private int hash = 0;

	final private RadioButtonGroupId id;
	final private RadioButtonGroupEvent cmd;
			
	private RadioButtonGroupIdEvent(
		 RadioButtonGroupId id
		, RadioButtonGroupEvent cmd
	) {
		this.id = id;
		this.cmd = cmd;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param cmd != null (mandatory)
	 */
	public static RadioButtonGroupIdEvent create(
		 RadioButtonGroupId id
		, RadioButtonGroupEvent cmd
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(cmd != null);

		return new RadioButtonGroupIdEvent(
			 id
			, cmd
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public RadioButtonGroupId getId() {
		return this.id;
	}
	/** field cmd, should never return null */
	public RadioButtonGroupEvent getCmd() {
		return this.cmd;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public RadioButtonGroupIdEvent setId(RadioButtonGroupId id) {	 
		SchemaException.ensure(id != null);
		return new RadioButtonGroupIdEvent(
			  id 		
			, this.cmd 		
		);		
	}
	/** create struct with field cmd modified, 
	 * (exception when arg==null) */
	public RadioButtonGroupIdEvent setCmd(RadioButtonGroupEvent cmd) {	 
		SchemaException.ensure(cmd != null);
		return new RadioButtonGroupIdEvent(
			  this.id 		
			, cmd 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof RadioButtonGroupIdEvent) 
			&& this.eq((RadioButtonGroupIdEvent)obj);
	}
	
	public boolean eq(RadioButtonGroupIdEvent obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqCmd(this, obj)
			;
	}

	private static boolean eqId(RadioButtonGroupIdEvent o1, RadioButtonGroupIdEvent o2) {
		RadioButtonGroupId f1 = o1.getId();
		RadioButtonGroupId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqCmd(RadioButtonGroupIdEvent o1, RadioButtonGroupIdEvent o2) {
		RadioButtonGroupEvent f1 = o1.getCmd();
		RadioButtonGroupEvent f2 = o2.getCmd();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("cmd" + "=");
		out.append(getCmd());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= this.cmd.hashCode() + 1227373034;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}