package nianio.complib.messagedialog;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * Autogenerated class MessageDialogKind =
 * variant (enumeration) {
 *	    info 
 *	 |  warning 
 *	 |  error 
 * }
 */ 
public class MessageDialogKind implements ImmObject {
	private static final int TYPE_HASH = 1886373955;


	private static final MessageDialogKind CONST_INFO = new MessageDialogKind(0);
	private static final MessageDialogKind CONST_WARNING = new MessageDialogKind(1);
	private static final MessageDialogKind CONST_ERROR = new MessageDialogKind(2);

	private final int variant;

	private MessageDialogKind(int variant) {
		this.variant = variant;
	}


	public static MessageDialogKind createInfo() {
		return CONST_INFO;
	}
	
	public static MessageDialogKind createWarning() {
		return CONST_WARNING;
	}
	
	public static MessageDialogKind createError() {
		return CONST_ERROR;
	}
	

	/* The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isInfo()) {
			;
		} else if (isWarning()) {
			;
		} else if (isError()) {
			;
		} else 		
			throw Err.errM(this);
	}


	/** @return true, when this is info */
	public boolean isInfo() {
		return variant == 0;
	}

	/** @return true, when this is warning */
	public boolean isWarning() {
		return variant == 1;
	}

	/** @return true, when this is error */
	public boolean isError() {
		return variant == 2;
	}




	public String toString() {
		if (isInfo())
			return "info";
		if (isWarning())
			return "warning";
		if (isError())
			return "error";
		throw SchemaException.err();
	}
	
	public boolean eq(MessageDialogKind obj) {
		if (obj == null)
			return false;
		return variant == obj.variant;
	}
	
	public boolean equals(Object obj) {
		return (obj instanceof MessageDialogKind) 
			&& this.eq((MessageDialogKind)obj);
	}

	public int hashCode(){
		return (variant*(variant-79) + 1601) ^ TYPE_HASH;
	}

 
		
}