package nianio.complib.messagedialog;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;


/** 
 * <pre>Autogenerated class MessageDialogParams = {
 *		  dialogKind  : MessageDialogKind
 *		  message  : String
 * }</pre>
 */ 

public class MessageDialogParams implements ImmObject {
	private static final int TYPE_HASH = 465049205;
	private int hash = 0;

	final private MessageDialogKind dialogKind;
	final private String message;
			
	private MessageDialogParams(
		 MessageDialogKind dialogKind
		, String message
	) {
		this.dialogKind = dialogKind;
		this.message = message;
	}
	

	/** Creates a struct record with given values
	 * @param dialogKind != null (mandatory)
	 * @param message != null (mandatory)
	 */
	public static MessageDialogParams create(
		 MessageDialogKind dialogKind
		, String message
	) {
		SchemaException.ensure(dialogKind != null);
		SchemaException.ensure(message != null);

		return new MessageDialogParams(
			 dialogKind
			, message
		);		
	}


	/* getters */
	
	/** field dialogKind, should never return null */
	public MessageDialogKind getDialogKind() {
		return this.dialogKind;
	}
	/** field message, should never return null */
	public String getMessage() {
		return this.message;
	}

	/* setters */
	
	/** create struct with field dialogKind modified, 
	 * (exception when arg==null) */
	public MessageDialogParams setDialogKind(MessageDialogKind dialogKind) {	 
		SchemaException.ensure(dialogKind != null);
		return new MessageDialogParams(
			  dialogKind 		
			, this.message 		
		);		
	}
	/** create struct with field message modified, 
	 * (exception when arg==null) */
	public MessageDialogParams setMessage(String message) {	 
		SchemaException.ensure(message != null);
		return new MessageDialogParams(
			  this.dialogKind 		
			, message 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof MessageDialogParams) 
			&& this.eq((MessageDialogParams)obj);
	}
	
	public boolean eq(MessageDialogParams obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqDialogKind(this, obj)
			&& eqMessage(this, obj)
			;
	}

	private static boolean eqDialogKind(MessageDialogParams o1, MessageDialogParams o2) {
		MessageDialogKind f1 = o1.getDialogKind();
		MessageDialogKind f2 = o2.getDialogKind();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqMessage(MessageDialogParams o1, MessageDialogParams o2) {
		String f1 = o1.getMessage();
		String f2 = o2.getMessage();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("dialogKind" + "=");
		out.append(getDialogKind());
		out.append(", ");
		out.append("message" + "=");
		out.append(getMessage());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.dialogKind.hashCode() + 815196748;
			h ^= this.message.hashCode() + -1448746825;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}