package nianio.genrap;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;


/** 
 * <pre>Autogenerated class ReportGenerationFailure = {
 *		  params  : ReportParams
 *		  cause  : String
 * }</pre>
 */ 

public class ReportGenerationFailure implements ImmObject {
	private static final int TYPE_HASH = 1618183774;
	private int hash = 0;

	final private ReportParams params;
	final private String cause;
			
	private ReportGenerationFailure(
		 ReportParams params
		, String cause
	) {
		this.params = params;
		this.cause = cause;
	}
	

	/** Creates a struct record with given values
	 * @param params != null (mandatory)
	 * @param cause != null (mandatory)
	 */
	public static ReportGenerationFailure create(
		 ReportParams params
		, String cause
	) {
		SchemaException.ensure(params != null);
		SchemaException.ensure(cause != null);

		return new ReportGenerationFailure(
			 params
			, cause
		);		
	}


	/* getters */
	
	/** field params, should never return null */
	public ReportParams getParams() {
		return this.params;
	}
	/** field cause, should never return null */
	public String getCause() {
		return this.cause;
	}

	/* setters */
	
	/** create struct with field params modified, 
	 * (exception when arg==null) */
	public ReportGenerationFailure setParams(ReportParams params) {	 
		SchemaException.ensure(params != null);
		return new ReportGenerationFailure(
			  params 		
			, this.cause 		
		);		
	}
	/** create struct with field cause modified, 
	 * (exception when arg==null) */
	public ReportGenerationFailure setCause(String cause) {	 
		SchemaException.ensure(cause != null);
		return new ReportGenerationFailure(
			  this.params 		
			, cause 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof ReportGenerationFailure) 
			&& this.eq((ReportGenerationFailure)obj);
	}
	
	public boolean eq(ReportGenerationFailure obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqParams(this, obj)
			&& eqCause(this, obj)
			;
	}

	private static boolean eqParams(ReportGenerationFailure o1, ReportGenerationFailure o2) {
		ReportParams f1 = o1.getParams();
		ReportParams f2 = o2.getParams();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqCause(ReportGenerationFailure o1, ReportGenerationFailure o2) {
		String f1 = o1.getCause();
		String f2 = o2.getCause();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("params" + "=");
		out.append(getParams());
		out.append(", ");
		out.append("cause" + "=");
		out.append(getCause());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.params.hashCode() + 1975075542;
			h ^= this.cause.hashCode() + -1610858215;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}