package nianio.ids;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * <pre>Autogenerated class MessageDialogId = variant {
 *	    generateFinish of String  
 * }</pre>
 */ 
public class MessageDialogId implements ImmObject {
	private static final int TYPE_HASH = -431556214;
	private int hash = 0;

	private final int variant;
	private final Object value;  


	private MessageDialogId(int variant, Object value) {
		SchemaException.ensure(value != null);
		this.variant = variant;
		this.value = value;
	}


	public static MessageDialogId createGenerateFinish(String value) {
		return new MessageDialogId(0, value);
	}



	/** @return true, when this is generateFinish */
	public boolean isGenerateFinish() {
		return variant == 0;
	}

	/** @return variant value, when this is generateFinish; throws Exception otherwise */
	public String asGenerateFinish() {
		SchemaException.ensure(isGenerateFinish());
		return ((String)value);
	}



	/** The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isGenerateFinish()) {
			;
		} else 		
			throw Err.errM(this);
	}

	/** The only purpose of this method is to inline its content - 
	 * match pattern with value unpacking. 
	 */ 
	public void matchUnpack() {
		if (isGenerateFinish()) {
			asGenerateFinish();
		} else 		
			throw Err.errM(this);
	}	

	public String toString() {
		if (isGenerateFinish())
			return "generateFinish" + "(" + asGenerateFinish() + ")";
		throw SchemaException.err();
	}
	
	public boolean eq(MessageDialogId obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return variant == obj.variant 
			&& (value == null ? (obj.value == null) 
			: (obj.value != null && value.equals(obj.value)));
	}

	public boolean equals(Object obj) {
		return (obj instanceof MessageDialogId) 
			&& this.eq((MessageDialogId)obj);
	}

	public int hashCode(){
		if (hash == 0) {
			int h = variant*(variant - 79) + 1601;
			if (value != null)
				h ^= value.hashCode();
			else
				h ^= TYPE_HASH;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
	
}